# once.rb: Written by Tadayoshi Funaba 1998, 2000

class Module

  def once(*ids)
    for id in ids
      module_eval <<-"end;"
	alias_method :__#{id.to_i}__, :#{id.id2name}
	def #{id.id2name}(*args, &block)
	  (@__#{id.to_i}__ ||= [__#{id.to_i}__(*args, &block)])[0]
	end
      end;
    end
  end

  private :once

  def once_class_method(*ids)
    for id in ids
      module_eval <<-"end;"
	class << self
	  once :#{id.id2name}
	end
      end;
    end
  end

  private :once_class_method

end

=begin
2002/05/16

 This script 'once.rb' was written by Funaba, thanks.
This is included into this package for convenience.
once or other Funaba's softwares is distributed on
  http://www.funaba.org/ruby.html
=end
